﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.51
@EndOfDesignText@
Sub Class_Globals
	Public FigureNameAndId As String = ""
	Public bw As X2BodyWrapper
	Public InAir As Boolean
	Public IsSmall As Boolean = True
	Public LastPositionIndex As Int = 0
	
	Private x2 As X2Utils 'ignore
	Private LastTickTime As Int
	Private SpecialState As Boolean
	Private FaceRight As Boolean = True
	Private MaxVelocity As Float = 10
	Private ImpulseVector As B2Vec2
	Private ProtectedTime As Int
End Sub

Public Sub Initialize (wrapper As X2BodyWrapper)
'	Log("#-Sub figure.Initialize")
	LastPositionIndex = 0
	bw = wrapper
	x2 = bw.X2
	bw.DelegateTo = Me
	UpdateImpulseVector
	CreateChar1Legs
End Sub

Private Sub CreateChar1Legs
	' see 1--> https://www.b4x.com/android/forum/threads/xui2d-super-mario-example-1.96151/
	' see 2--> https://www.b4x.com/android/forum/threads/xui2d-super-mario-example-2.96236/
	Dim rect As B2PolygonShape
	rect.Initialize
	rect.SetAsBox2(0.45, 0.05, x2.CreateVec2(0, -x2.GetShapeWidthAndHeight(bw.Body.FirstFixture.Shape).y / 2 + 0.05), 0)
	Dim f As B2Fixture = bw.Body.CreateFixture2(rect, 0.1)
	f.Friction = 1
	f.Tag = "legs"
End Sub

Private Sub UpdateImpulseVector
	'Log("#-Sub figure.UpdateImpulseVector, bw.Name=" & bw.Name)
	ImpulseVector = x2.CreateVec2(0.5 * bw.Body.Mass * x2.TimeStepMs / 16, 0) 
End Sub

Public Sub Hit_Start (ft As X2FutureTask)
	If SpecialState Then Return
	If x2.gs.GameTimeMs < ProtectedTime Then Return


	
End Sub

Private Sub StartGameOver
	SpecialState = True
'	bw.GraphicName = "Char1 small strike"
'	bw.Body.FirstFixture.SetFilterBits(0, 0)
'	bw.Body.FirstFixture.NextFixture.SetFilterBits(0, 0)
'	bw.Body.LinearVelocity = x2.CreateVec2(0, 15)
	bw.mGame.GameOver
End Sub

Public Sub Tick (GS As X2GameStep)
	If LastTickTime = GS.GameTimeMs Then Return
	LastTickTime = GS.GameTimeMs
	
	'Log("#-Sub figure.Tick --> " & bw.Name)
	
	
	' ...
	
	
	
	If GS.ShouldDraw Then
		bw.UpdateGraphic(GS, True)
	End If
End Sub

Public Sub IsLegsFixture (Fixture As B2Fixture) As Boolean
	Return Fixture.Tag <> Null And Fixture.Tag = "legs"
End Sub
 